<template>
    <header>
        <div>
            <h1>InstaClone</h1>
        </div>
        <div>
            <input type="text">
        </div>
        <div>
            <button class="like-container" @click="showModal"> 
                <i class="fa-regular fa-heart icon-svg"></i>
                <span class="count-notification">{{CountNotification}}</span>
            </button>
        </div>
    </header>
        <div v-if="isModalVisible" class="modal-backdrop" @click="closeModal">
            <div class="modal" @click.stop>
                <div class="modal-content" v-for="notification in NotificationObject" :key="notification">
                    <img v-if="notification.profil_pic == null" src="../assets/images/default_avatar.jpg" alt="" class="img-profil-modal">
                    <p v-if="notification">{{ notification.text }}</p>
                    <p v-else>Aucune nouvelle notification</p>
                    <img v-if="notification.image" class="notification-image" :src="'http://localhost:3500/api/srcImage/' + notification.image" alt="">
                </div>
            </div>
        </div>
</template>

<script>

    import axios from 'axios';
    import { useStore } from '../store/store';
    // import NotificationModal from './NotificationModal.vue';

    export default {
    name: "headerNavigation",

    components: { 
        // NotificationModal
     },

    data() {
        const store = useStore();
        return {
            store,
            isModalVisible: false
        };
    },
    computed: {

        user() {
            return this.store.getCurrentUser;
        },

        NotificationObject(){
            if (this.user.notification){
                // console.log(this.user.notification);
                return this.user.notification;
            }
            else{
                return 0
            }
        },

        CountNotification() {
            if (this.user.notification) {
                return this.user.notification.length;
            }
            else {
                return 0;
            }
        }
    },
    mounted() {
        // setinterval pour rgearder les notifs
        // polling pas webseckotet
        this.interval = setInterval(() => {
            axios.get("http://localhost:3500/api/user/data/" + this.user._id)
                .then(res => {
                this.store.$patch((state) => {
                    state.currentUser.notification = res.data.notification;
                });
            });
        }, 5000);
        // console.log(this.user);
        // this.CountNotification = this.user?.notification.length
        // console.log(this.CountNotification);
    },

    methods:{
        close(){

        },
        showModal() {
            this.isModalVisible = true;
            console.log(this.notificationObject)
        },
        closeModal() {
            this.isModalVisible = false;
            axios.post("http://localhost:3500/api/notification/delete/" + this.user._id)
            .then(res => {
                console.log(res)
                this.store.$patch((state) => {
                    state.currentUser.notification = [];
                });
            }) 
            .catch(err => {
                console.log(err);
            })
        },
    },

    beforeUnmount() {
        // clear interval 
        clearInterval(this.interval);
    }
}

</script>

<style scoped>

header{
    display: flex;
    flex-direction: row;
    width: 50%;
    justify-content: space-between;
    align-items: center;
    margin: auto;
}
.like-container{
    position: relative;
    display: flex;
    justify-content: center;
    align-items: center;
    border: none;
    outline: none;
    border-radius: 50%;
    background: #dddddd;
    width: 50px;
    height: 50px;
    cursor: pointer;
}
.like-container:hover{
    background: #cccccc;
}
.count-notification{
    position: absolute;
    display: flex;
    justify-content: center;
    align-items: center;
    top: -10px;
    right: -10px;
    width: 25px;
    height: 25px;
    background: red;
    color: white;
    border-radius: 50%;
}
.modal-backdrop {
    position: fixed;
    top: 0;
    bottom: 0;
    left: 0;
    right: 0;
    background-color: rgba(0, 0, 0, 0.15);
    display: flex;
    justify-content: center;
    align-items: center;
  }
  .modal {
    background: #FFFFFF;
    overflow-x: auto;
    display: flex;
    flex-direction: column;
    height: 80%;
    width: 70%;
  }
  .modal-content{
    display: flex;
    flex-direction: row;
    width: 100%;
  }
  .notification-image{
    width: 5rem;
    height: 5rem;
  }
  .img-profil-modal{
    width: 3rem;
    height: 3rem;
    border-radius: 50%;
  }

</style>